From 0c66732d302d4c4693c896e29362f694bb5656ec Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Wed, 28 Jul 2010 11:31:37 +0900
Subject: [PATCH 09/51] copy nd_omod in COPY_CREF().

---
 vm_insnhelper.h |    7 ++++++-
 1 files changed, 6 insertions(+), 1 deletions(-)

diff --git a/vm_insnhelper.h b/vm_insnhelper.h
index 6d13113..3852ee5 100644
--- a/vm_insnhelper.h
+++ b/vm_insnhelper.h
@@ -151,7 +151,12 @@ extern VALUE ruby_vm_const_missing_count;
 
 #define COPY_CREF(c1, c2) do {  \
   NODE *__tmp_c2 = (c2); \
-  c1->nd_omod = __tmp_c2->nd_omod; \
+  if (NIL_P(__tmp_c2->nd_omod)) { \
+      c1->nd_omod = __tmp_c2->nd_omod; \
+  } \
+  else { \
+      c1->nd_omod = rb_hash_dup(__tmp_c2->nd_omod); \
+  } \
   c1->nd_clss = __tmp_c2->nd_clss; \
   c1->nd_visi = __tmp_c2->nd_visi;\
   c1->nd_next = __tmp_c2->nd_next; \
-- 
1.7.0.4

